//\frame{
import java.io.*;
import java.util.*;


public class PTD2 {
  private FileInputStream file;
  private StreamTokenizer st;
  private int slideCount;
SlideConnection SC;  

  public int getSlideCount(){return slideCount;};

  PTD2(String filename)
    throws FileNotFoundException {
    try {
      file = new FileInputStream(filename);
      st = new StreamTokenizer(file);
      
      SC = new SlideConnection();


      st.resetSyntax();
      st.eolIsSignificant(true);
      st.wordChars(48,57);
      st.wordChars(65,90);
      st.wordChars(97,122);
      
      st.ordinaryChars(32,32);

      st.wordChar('');

      
    } catch(FileNotFoundException e) {
      System.out.println(
        "Could not open " + filename);
      throw e;
    }
  }
  void cleanup() {
    try {
      file.close();
    } catch(IOException e) {
      System.out.println(
        "file.close() unsuccessful");
    }
  }
  void showHappen() {
    try {
      boolean withinSlide=false;
      boolean commentRow=false;
      boolean commentRowEnd=false;
      
      int openedBrackets=0;
      int closedBrackets=0;
      
      slideCount=0;

      
      String lastString="";
      String s="";
      
      while(st.nextToken() != StreamTokenizer.TT_EOF) 
      {
        lastString=s;
        switch(st.ttype) {
          case StreamTokenizer.TT_EOL:
            s = new String("\n");
            commentRowEnd=true;
            break;
       /*   case StreamTokenizer.TT_NUMBER:
            s = Double.toString(st.nval);
            System.out.println("Here Number!!!!!!!!!");
            break; */
          case StreamTokenizer.TT_WORD:
            s = st.sval; // Already a String
            break;
          default: // single character in ttype
            s = String.valueOf((char)st.ttype);

            // hier werden die geffneten und schlieenden geschwungenen Klammern gezhlt
            // und LaTeX-Kommentare bercksichtigt
              if (withinSlide&&s.equals("{")&&!lastString.equals("\\")&&!commentRow) 
              {  
                openedBrackets++;
                if(openedBrackets==1)continue; // %\frame{-Klammer ->weg
              }
              else
              if (withinSlide&&s.equals("}")&&!lastString.equals("\\")&&!commentRow) closedBrackets++;
              else
              if (s.equals("%")&&!lastString.equals("\\")&&!commentRow)
              {
                commentRow=true;
                commentRowEnd=false;
                // debug mode System.out.println("commentstart");
              }
            
        }
        if(!withinSlide&&s.equals("frame")&&lastString.equals("\\")&&!commentRow)
        {
          //           debug mode 
          System.out.println("****************************framestart");
          slideCount++;
          
          withinSlide=true;
          
          openedBrackets=0;
          closedBrackets=0;
        }
        if(withinSlide&&(openedBrackets==closedBrackets)&&(openedBrackets>0))
        {  
          withinSlide=false;
          // System.out.println("");
          // debug mode 
          System.out.println("############################framestopp");
        }
        if(withinSlide&&openedBrackets>0)System.out.print("["+s+"]");// debug mode         else System.out.print("["+s+"]");
//        if(withinSlide&&openedBrackets>0)if(s.length()>2)SC.doMySqlUpdate("insert ignore into wordindex (word) values (\""+s+"\");");
//        if(s.length()>2)System.out.println("insert into wordindex (word) values (\""+s+"\");");


        if(commentRow&&commentRowEnd)commentRow=false;
        //System.out.print("["+s+"]");
      }
//    System.out.println("");  
    System.out.println(slideCount+"Folien gefunden.");

      
    } catch(IOException e) {
      System.out.println(
        "st.nextToken() unsuccessful");
    }
    
  }

  public static void main(String[] args) {
    try {
      PTD2 wc =
        new PTD2(args[0]);
      wc.showHappen();
      wc.cleanup();
    } catch(Exception e) {
      e.printStackTrace();
    }
  }
}
//}
